' definitions & initializations
  OPTION BASE 1 : OPTION DEFAULT FLOAT : OPTION EXPLICIT ' see MMBasic Manual
'  option baudrate 115200
'  option autorun on
  CONST TRUE=1,FALSE=0,cON=TRUE
  const SIMULATE=TRUE, HTMLDISPLAY=TRUE ' set run directions
  CONST maxVars=83  ' max # html simulation output variables
  const hVarmax=26  ' max # html simulation update (input) variables
  const MaxLen=1024 ' max html input buffer length
  CONST longStringMaxLen=4096 ' maximum size of long string (e.g., html template text)
  const starttext$="HTTP" ' search html input for this to find end of command string
  const pnf$="<html><body>Page not Found</body></html>" ' page not found html code
  const cBackGroundOFF="#ff0000" ' red ' html background color--relay off #7fff00
  const cBackGroundON ="#7fff00" ' chartreuse  ' html background color--relay oo #ff0000
  CONST cOFF=0,cAUTO=1,cMANUAL=2   ' iOpMode values
  ' the following are indexes into sVarVals, data for the html & display pages
  const MODE_OFF=5,MODE_AUTO=6,MODE_MANUAL=7
  const CIRCULATOR=10,FAN_OUT=11,LOUVER_VENT=12,FAN_IN=4,MISTER=14,HEATER=21,LIGHTS=16,DEHUMID=17 ' index into sVarVals
  const OUTTEMP=30,INTEMP=31,CIRCSUPPLY=34,CIRCRETURN=35,OUTHUMI=32,INHUMI=33 ' index into sVarVals
  const MAINS=8,BATTERY=9,DOOR=3,MOTION=4     ' index into sVarVals           
  ' the following are pin numbers for relays/MOSFET modules
' LEDs: CIRC=Red,HEAT=Amber,FANIN=Green,FANOUT=Blue,MIST=White,LOUVER=Yellow
'  CONST pCIRCULATOR=24, pLouver_Vent=25, pMister=26, pFan_Out=27, pFan_In=31, pHeater=34
'  CONST pLights=15,pDehumid=14
  CONST pCIRCULATOR=20, pLouver_Vent=19, pMister=17, pFan_Out=16, pFan_In=15, pHeater=5
  CONST pLights=4,pDehumid=2
  ' the following are pin numbers for sensor,
'  CONST pInTemp=32,pOutTemp=29,pCircInTemp=22,pCircOutTemp=21  ' ,pGener=19
  CONST pInTemp=32,pOutTemp=34,pCircInTemp=6,pCircOutTemp=7  ' ,pGener=19
'  CONST pMains=20,pBattery=19,pDoor=16,pMotion=17
  CONST pMains=29,pBattery=31,pDoor=10,pMotion=9
  const nRelayPins=8, nTempPins=4
  const dspin=2 ' inside temperature
  CONST qt=chr$(34) ' double quote
  CONST cNotChecked="......."
  
initial:
  Dim buff%(512)
  Dim integer nnn%
  WEB tcp interrupt TCPrequest
   nnn% = 0
   DATE$ = "01-04-2000"
   DO
     ON ERROR SKIP
     WEB ntp -5
     IF DATE$ = "01-04-2000" THEN PRINT "NTP OOPSIE!"
     INC nnn%
   LOOP UNTIL DATE$ <>"01-04-2000" OR nnn% > 4
   initialize
  
main:
  do
'    watchdog 60000 ' lb if not executed in 60 seconds, restart'    
'    GetUserInputs  ' get inputs from local display
    ReadSensors    ' get temperature and humidity
'    DisplayData
  loop

Sub TCPrequest
 Local p%, t%, ii%, ss$
 For ii%=1 To mm.info(max connections)
   If Not MM.Info(TCP request ii%) Then Continue For
   LongString clear buff%()
   WEB tcp read ii%,buff%()
   p%=LInStr(buff%(),"GET")
   t%=LInStr(buff%(),"HTTP")
   If Not LLen(buff%()) Then Continue For
   ss$=""
   If (p%<>0) And  (t%<>0) And (t%>p%) Then
     if sLastGet<>ss$ then ' new user input available
       ss$=LGetStr$(buff%(),p%,t%-p%+4)
       Print "String is ",ss$
       sLastGet=ss$
     endif
	 if instr(ss$,"G?") then ' check for sensor changes
       parseHTMLdata(ss$)
       WEB transmit page ii%,"gh.html" ' "gh.html"
     endif
   EndIf
   If Instr(ss$,"small") Then
     Print "sending picture"
     WEB Transmit FILE ii%,"small.jpg","image/jpeg"
   ElseIf Instr(ss$,"favicon") Then
     Print "sending icon"
     WEB Transmit FILE ii%,"LB_Flag.ico","image/vnd.microsoft.icon" ' favicon.ico
   ElseIf Instr(ss$,"HTTP") Then
     Print "sending page"
     WEB transmit page ii%,"gh.html" ' "gh.html"
   EndIf
 Next ii%
End Sub

sub GetUserInputs
'  if LOC(2) > 1 then ' input buffer for Nextion has at least two bytes
'    getNextionCommand
'  ENDIF ' input available on serial port #2
end sub

sub ReadSensors
  if ds18B20timeout < timer then
'    insideTemp=cint(tempr(dspin)*9/5)+32 ' *10) 'read the temperature from the last conversion
'    tempr start dspin,3 'start a new temperature conversion
    ds18B20timeout = timer+1000 ' wait 1 second before reading
'    insideTemp=tempr(pInTemp)*9/5+32: if insideTemp>=1000 then: insideTemp=1000: endif
'    outsideTemp=tempr(pOutTemp)*9/5+32: if outsideTemp>=1000 then: outsideTemp=1000: endif
'    iCircSupplyTemp=tempr(pCircOutTemp)*9/5+32: if iCircSupplyTemp>=1000 then: iCircSupplyTemp=1000: endif
'    iCircReturnTemp=tempr(pCircInTemp)*9/5+32: if iCircReturnTemp>=1000 then: iCircReturnTemp=1000: endif
'  CONST pInTemp=32,pOutTemp=34,pCircInTemp=6,pCircOutTemp=7  ' ,pGener=19
    for i=1 to 4
      bitbang humid iTempPins(i),t1!,h1!  ' ,AM2320 bitbang humid 32,t1!,h1!
      if t1!<>1000 then 
        select case i
          case 1: insideTemp=t1!*9/5+32
          case 2: outsideTemp=t1!*9/5+32
          case 3: iCircSupplyTemp=t1!*9/5+32
          case 4: iCircReturnTemp=t1!*9/5+32
        end select
      endif
    next i
' endif
    sVarVals(OUTTEMP)=str$(outsideTemp,0)
    sVarVals(INTEMP)=str$(insideTemp,0)
    sVarVals(CIRCSUPPLY)=str$(iCircSupplyTemp,1)
    sVarVals(CIRCRETURN)=str$(iCircReturnTemp,1)
    if pin(pMains) then: sVarVals(MAINS)=cBackGroundON: else: sVarVals(MAINS)=cBackGroundOFF: endif 
    if pin(pBattery) then: sVarVals(BATTERY)=cBackGroundON: else: sVarVals(BATTERY)=cBackGroundOFF: endif 
    if pin(pDoor) then: sVarVals(DOOR)=cBackGroundON: else: sVarVals(DOOR)=cBackGroundOFF: endif 
    if pin(pMotion) then: sVarVals(MOTION)=cBackGroundON: else: sVarVals(MOTION)=cBackGroundOFF: endif 
  endif
  pause 1000
''LB  if flagSensorChanged then : NXLoadSensorReadings : flagSensorChanged=FALSE : endif
' set in parseHTMLdata  mainsOK=pin(pMains): batteryOK=pin(pBattery): doorOK=pin(pDoor): motionOK=pin(pMotion)
end sub
  
Sub parsehtmldata(params$ as string)
' e.g.: G?Y=0&W=2&W=5&A=&B=&C=74&D=&E=&F=
  local a$,b$,c$,sOPs$,sNewOPs$
  local integer kk%
  flagVarChanged = FALSE
  i=instr(params$," HTTP")
  params$=mid$(params$,1,i-1)+"&" ' terminate parameter string with "&"
  for j=50 to 57: if sVarVals(j)="checked" then: sOPs$=sOPs$+"1": else: sOPs$=sOPs$+"0": endif: next j
  sNewOPs$="00000000" ' assume all off
  i=4
  i=instr(i,params$,"=")
  do while i>0
    c$=mid$(params$,i-1,1) ' get 1-char item code, e.g. Y,W,A,B,C,D,E,F
 '     Y=mode: 0,1,2=off,auto,manual; W=ckbox: 1-6=CIRCULATOR,LOUVER VENT,MISTER,FAN OUT,FAN IN,HEATER 
     ' simulation inputs
 '     A=OutsideTemp~40; B=InsideTemp~41; C=OutsideHumidity~42; D=InsideHumidity~43; 
 '     E=Circulator Supply~44; F=Circulator Return~45
     ' sensor readings (or simulation input values)
 '     A=OutsideTemp~30; B=InsideTemp~31; C=OutsideHumidity~32; D=InsideHumidity~33; 
 '     E=Circulator Supply~34; F=Circulator Return~35
    select case c$
      case "Y" ' mode: sVarVals(5-7)
        a$=mid$(params$,i+1,1) ' get value
        if a$>="0" and a$ < "3" then ' possible change in mode
          k=val(a$) ' 0,1,2
          iOPmode=k
          if sVarVals(k+5)<>"checked" then ' change in mode
            flagVarChanged = TRUE
            for j=5 to 7 
              if j=(k+5) then
                sVarVals(j)="checked"  '  checked values are ~5 - ~7
              else
                sVarVals(j)="......."  '  uncheckedchecked values are ~5 - ~7
              endif
            next j
          endif 
  ? "LB Y ",k, sVarVals(5),sVarVals(6),sVarVals(7)         
        endif        
      case "W" ' checkbox: color: sVarVals(10-15); checked: sVarVals(50-57)
              '1-6=CIRCULATOR,LOUVER VENT,MISTER,FAN OUT,FAN IN,HEATER
        a$=mid$(params$,i+1,1) ' get value
        if a$>="0" and a$ < "9" then ' possible change in output pin
          k=val(a$)
          if k=1 then 
            sNewOPs$="1"+mid$(sNewOPs$,2)
          else
            sNewOPs$=mid$(sNewOPs$,1,k-1)+"1"+mid$(sNewOPs$,k+1)
          endif
        endif
  ? "Pin: "+c$+" "+a$+" ";iRelayPins(int(val(a$)));" "+sOPs$+"->"+sNewOPs$
      case else ' "A"-"F"
' e.g.: G?Y=0&W=2&W=5&A=&B=&C=74&D=&E=&F=
     ' sensor readings (or simulation input values)
 '     A=OutsideTemp~30; B=InsideTemp~31; C=OutsideHumidity~32; D=InsideHumidity~33; 
 '     E=Circulator Supply~34; F=Circulator Return~35
        j=instr(i,params$,"&") ' terminating character or 0
        if (j-i-1) >0 then ' there's a value
          a$=mid$(params$,i+1,j-i-1) ' get value
          k=val(a$)
  ? i,j,c$,a$,k,mid$(params$,i-1)
          sVarVals(asc(c$)-35)=str$(k) ' e.g.m "A" is ascii 65, minus 25 is HTML item ~40--OutsideTemp
          flagVarChanged = TRUE
        endif
    end select
    i=i+1
    i=instr(i,params$,"=")
  loop
  if sOPs$<>sNewOPs$ then ' output pin settings have changed
    ' checkbox: color: sVarVals(10-15); checked: sVarVals(50-57)
              '1-6=CIRCULATOR,LOUVER VENT,MISTER,FAN OUT,FAN IN,HEATER
 '? "LB "+sOPs$+"<-"+sNewOPs$
    sOPs$=sNewOPs$
    flagVarChanged = TRUE
    for i=50 to 57
      a$=mid$(sOPs$,i-49,1) 
'  ? "LB ";i;" "+a$+" ";
      if a$="1" then
        sVarVals(i)="checked"
        if iOPmode = cAUTO or iOPmode = cMANUAL) then ' 1 or 2
          if pin(iRelayPins(i-49))<>cON then ' a change
            sVarVals(i-40)=cBackGroundON '  colors
            pin(iRelayPins(i-49))=cON ' iRelayPins 1-6
            ? "pin ";iRelayPins(i-49);" ON"
          endif 
        else
          if pin(iRelayPins(i-49))<>cOFF then ' a change
            sVarVals(i-40)=cBackGroundOFF
            pin(iRelayPins(i-49))=cOFF
            ? "pin ";iRelayPins(i-49);" OFF"
          endif
        endif
      else
        if pin(iRelayPins(i-49))<>cOFF then ' a change
          sVarVals(i)="......." ' not checked
          sVarVals(i-40)=cBackGroundOFF
          pin(iRelayPins(i-49))=cOFF
          ? "pin ";iRelayPins(i-49);" OFF"
        endif
      endif
'?  sVarVals(i);" ";sVarVals(i-40)
    next i
  endif
  if pin(pMains)<>mainsOK or pin(pBattery)<>batteryOK then
    flagVarChanged=TRUE
	mainsOK=pin(pMains)
	batteryOK=pin(pBattery)
  endif
  if pin(pDoor)<>doorOK or pin(pMotion)<>motionOK then
    flagVarChanged=TRUE
	doorOK=pin(pDoor)
	motionOK=pin(pMotion)
  endif
  if flagVarChanged then
    for i=40 to 45
      sVarVals(i)="" ' clear simulated value fields
    next i
    putHTML
  endif
End Sub ' parsehtmldata$
  
sub initialize
  Dim arg$(2,hVarmax) length 20
  DIM integer inbuf(Maxlen\4) 'global input buffer
  dim integer nparams, ds18B20timeout
  DIM as string htmlRequest$
  dim as integer htmlBuffer(longStringMaxLen/4) ' LB 170310
  DIM AS STRING htmlLine, templateLine, sHTMLVarNo 
  '                                                        01234567
  DIM AS STRING sCheckboxSettings="00000000", sOldCheckboxSettings ' "101010xx"
  DIM AS STRING sRelaySet1Val, sRelaySet2Val, sOldRelaySet1Val, sOldRelaySet2Val
  DIM AS INTEGER iRelaySet1Val, iRelaySet2Val, iOldRelaySet1Val, iOldRelaySet2Val, iRelaySet1Ck
  dim as integer iRelayPins(8) = (pCIRCULATOR,pLouver_Vent,pMister,pFan_Out,pFan_In,pHeater,pLights,pDehumid)
  dim as integer iRelayPinNo
'  CONST pInTemp=32,pOutTemp=34,pCircInTemp=6,pCircOutTemp=7  ' ,pGener=19
  dim as integer iTempPins(4) = (pInTemp,pOutTemp,pCircInTemp,pCircOutTemp)
  DIM AS INTEGER i,j,k,l,m,n,iContentLength
  DIM AS INTEGER nVarNdx(maxVars), nVarNos(maxVars)
  dim as integer flagNXUpdated, flagHTMLupdated, flagNoOutput
  dim as string sFrom, sTo, sTmp, sMinuteDigit, sLength, sLastGet="xxx" 
  DIM AS string sVarVals(83) length 40
'  dim AS string sDay, sDayOfWeek(7) length 10 = ("Monday","Tuesday","Wednesday", 
'             "Thursday","Friday","Saturday","Sunday")
  dim AS string sDay, sDayOfWeek(7) length 10 = ("Mon","Tue","Wed","Thu","Fri","Sat","Sun")
  dim as integer iDayOfWeek, iToday, iMaxsVarVal=58
  dim as integer iOpMode=0 ' 0=OFF,1=AUTO,2=MANUAL
'  DIM as string sMonthNames(12) = ("January","February","March","April","May","June",
'                           "July","August","September","October","November","December")
  DIM as string sMonthNames(12) = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","","","")
  sMonthNames(10)="Oct":sMonthNames(11)="Nov":sMonthNames(12)="Dec"
  dim integer iMonth, iMasterLoopCount, iTotalLoopCount=0, iTotalLoopPeriods=0
  dim integer outsideTemp, insideTemp, iOutsideHumidity, iInsideHumidity
  dim integer iCircSupplyTemp, iCircReturnTemp, mainsOK, batteryOK, doorOK, motionOK
  dim float fLoopCountTimeout, fLoopCountLength, rtc17, rtc18
  dim as integer firstSend=1
  DIM as string obuff$="" 'used to buffer writes to the internet to optimise speed
  DIM as string htmlElementName ' A-F oTemp,iTemp,oHum,iHum,circSup,circRet
  DIM as string htmlElementValue ' A-F oTemp,iTemp,oHum,iHum,circSup,circRet
  DIM as string sContentLength ' length of html display output
  dim integer iPos, jPos, flagVarChanged, flagSensorChanged, flagFirstPassAfterSim ' LB 170303
  dim as string sON, sOFF, sCh
  dim string CRLF=chr$(13)+chr$(10)
  dim float fTemps(4),fHumids(4),t1!,h1!
  'Chartreuse, red
  
  newday
  memory
  newMinute: sVarVals(2)=mid$(time$,1,5): ? "Time: "+sVarVals(2)
  readHTMLTemplate
  iMasterLoopCount = 0
  fLoopCountLength = 120 ' 5 minutes ' 600 ' 10 minutes -- 120 ' 2 minutes
  fLoopCountTimeout = TIMER + (1000*fLoopCountLength)
'  insideTemp = tempr(dspin,3)*9/5+32
  print "Temp: "+str$(insideTemp,0)+"C "+str$(insideTemp*9/5+32,0)+"F" 'measure temp to 0.0625 degree accuracy
'  tempr start dspin,3 'start a new temperature conversion--takes up to 750ms
  ds18B20timeout = timer+1000 ' wait 1 second before reading
  iOldRelaySet1Val=0 ' all relays off
'  CONST pCIRCULATOR=26, pLouver_Vent=25, pMister=24, pFan_Out=23, pFan_In=16, pHeater=15
  for i = 1 to nRelayPins : SETPIN iRelayPins(i), DOUT : next i ' set relay pins as output
  setpin pMains,DIN,pullup
  setpin pBattery,DIN,pullup
  setpin pMotion,DIN,pullup
  setpin pDoor,DIN,pullup
'  for i = 1 to nRelayPins : pin(iRelayPins(i)) = cON : pause 1000 : next i ; turn pins on
'  for i = 1 to nRelayPins : pin(iRelayPins(i)) = cOFF : pause 1000 : next i ; turn pins 
  ds18B20timeout=0
  ReadSensors
  PRINT "DS3231 temperature: ";insideTemp
  if SIMULATE then
     ? "SIMULATION ON!
    flagVarChanged = TRUE    ' outsideTemp, insideTemp, etc
'    insideTemp=insideTemp+3
'    outsideTemp = insideTemp - 6.5
    iOutsideHumidity=insideTemp-3.1
    iInsideHumidity=insideTemp-6.0
'    iCircSupplyTemp=insideTemp+15
'    iCircReturnTemp=insideTemp+9
    ' const CIRCULATOR=10,FAN_OUT=11,LOUVER_VENT=12,FAN_IN=13,MISTER=14,HEATER=15
    ' sVarVals(CIRCULATOR)=cBackGroundOFF
    for i = CIRCULATOR to HEATER : sVarVals(i)=cBackGroundOFF : next i
    sVarVals(MODE_OFF)="checked"
'  const OUTTEMP=30,INTEMP=31,OUTHUMI=32,INHUMI=33,CIRCSUPPLY=34,CIRCRETURN=35
    sVarVals(INHUMI)=str$(iInsideHumidity,1)
    sVarVals(OUTHUMI)=str$(iOutsideHumidity,1)
    sVarVals(CIRCSUPPLY)=str$(iCircSupplyTemp,1)
    sVarVals(CIRCRETURN)=str$(iCircReturnTemp,1)
'    outsideTemp = insideTemp - 6.5
    sVarVals(OUTTEMP)=str$(outsideTemp,0)
    sVarVals(INTEMP)=str$(insideTemp,0)
    sVarVals(MAINS) = cBackGroundON
    sVarVals(BATTERY) = cBackGroundON
    sCheckboxSettings="00000000" ' "0000000" all off
  endif
''LB  var restore ' restore after power outage or autorun restart--iOpMode & sCheckboxSettings
  for i=50 to 57 
    j = i - 49
    sCh = mid$(sCheckboxSettings,j,1)
    if sCh = "1" then
      sVarVals(i) = "checked" : sVarVals(i-40) = cBackGroundON 
    else
      sVarVals(i) = cNotChecked : sVarVals(i-40) = cBackGroundOFF 
    endif    
'    print "iOpMode, ckboxes: ";iOpMode;" ";sCheckboxSettings
  next i
  flagNoOutput=TRUE
  iContentLength = 0
''LB  drawpage  ' get sContentLength
  sContentLength=str$(iContentLength)
  flagNoOutput=FALSE
  print "HTML Content-Length: "+sContentLength
''  initNextion
'  for i=1 to maxVars: if sVarVals(i)<>"" then: ? i;" "+sVarVals(i): endif: next i ' debug
  putHTML
end sub
  
sub readHTMLTemplate
  LOCAL as string AA$(20),BB$
   
  longstring Clear htmlBuffer()
  BB$="gretempl.txt"
  open BB$ for input as #1 ' simulation
  print "opening "+BB$+" as #1 for simulation html template"
  do while not eof(#1)
    line input #1,BB$
'    htmlBuffer = htmlBuffer + templateLine
    BB$=BB$+crlf
    longstring append htmlBuffer(), BB$
  loop
  close #1
  j = LInstr(htmlBuffer(),"~")
  i = 1
  n = 1
'  DIM AS INTEGER nVarNdx(maxVars), nVarNos(maxVars)
  do while j > 0
    sHTMLVarNo = LGetStr$(htmlBuffer(),j+1,2)
    k = VAL(sHTMLVarNo)
    if k > 0 and k <= maxVars then
      nVarNdx(n) = j ' character after end of string
      nVarNos(n) = k
'  print "nijk "+str$(n)+" "+str$(i)+" "+str$(j)+" "+str$(k)
      n = n + 1
    else
      PRINT "Invalid varNo: ";htmlBuffer
    endif
    i = j + 3
   j = LInstr(htmlBuffer(),"~",i)
  loop
  nVarNdx(n) = 99999 ' invalid length
  print str$(n)+" variables found in html template"
end sub
  
Sub newday
'  rtc GETREG 3,iDayOfWeek
'  iDayOfWeek = iDayOfWeek mod 7 + 1
  iDayOfWeek = ((epoch(now)/86400) + 2) mod 7 +1
  print "DOW: "+str$(iDayOfWeek)+" -- ",sDayOfWeek(iDayOfWeek)
  iMonth=val(mid$(date$,4,2))
  if mid$(DATE$,1,1)="0" then
    sDay = mid$(date$,2,1)
  else
    sDay = mid$(date$,1,2)
  endif
  iToday = val(sDay)
  sVarVals(1)=sDayOfWeek(iDayOfWeek)+", "+sMonthNames(iMonth)+" "+sDay+", "+mid$(DATE$,7)
  sVarVals(2)=mid$(time$,1,5) ' "8:52pm"
  print sVarVals(1)+" "+sVarVals(2)
end sub
  
sub logToFile(id as string, a as string)
  local timeStamp as string
  timeStamp = mid$(DATE$,9)+mid$(DATE$,4,2)+mid$(DATE$,1,2)
  timeStamp = timeStamp+mid$(time$,1,2)+mid$(time$,4,2)+mid$(time$,7,2)
'  open "log.txt" for append as #8 ' log
'  print #8,timeStamp+" "+id+" "+a
'  close #8
end sub

sub putHTML
  local AA$
  print "Writing changed gh.html"
  open "gh.html" for output as #1
  n = 1
  i = 1
  j = nVarNdx(n)
  do while j <> 99999
' print "$$$ "+str$(n)+" "+str$(nVarNdx(n))
    k = j - i
    do while k > 250
	  AA$=LGetStr$(htmlBuffer(),i,250)
      sendText AA$
      k = k - len(AA$)
      i = i + len(AA$)
    loop
'    sendText mid(htmlBuffer,i,j-i)+sVarVals(nVarNos(n))
    sendText LGetStr$(htmlBuffer(),i,k)
    sendText sVarVals(nVarNos(n))
    n = n + 1
    i = j + 3
    j = nVarNdx(n)
  loop
'  sendText mid(htmlBuffer,i)
  AA$=LGetStr$(htmlBuffer(),i,200)
'  print "$$$> "+str$(len(AA$))+" ";
'  print AA$
  do while len(AA$)>0
    sendText AA$
	i=i+len(AA$)
    AA$=LGetStr$(htmlBuffer(),i,200)
'	print AA$+"$$$"
  loop
'  print "$$$ END"
  EndSend
  close #1
  print "Closing gh.html. Ready for user input"
end sub
  
sub SendText(aa$) ' buffer to speed up html output
  local ii%,jj%
  iContentLength = iContentLength + Len(aa$)
  if flagNoOutput then ' first pass only--count output characters
  else
    if firstSend = 1 then
      firstSend = 0
      ii%=instr(aa$,"title")
      if ii%>0 then: ii%=ii%+6: jj%=instr(aa$,"</")
        if jj%>0 then: ? mid$(aa$,ii%,jj%-ii%): endif ' print title
      endif
'      print aa$
    endif
    if len(aa$)+len(obuff$)< 240 then 'add the new string to the output buffer
      obuff$=obuff$+aa$
    else 'too big to fit so send the current output buffer
      print #1,obuff$;
'	  print obuff$;
      obuff$=aa$
    endif
  endif
end sub
  
sub EndSend
  print #1,obuff$
  print #1, ""
'  print obuff$;
  obuff$=""
end sub
  
